package com.hfut.schedule.logic.util

import com.hfut.schedule.App.MyApplication
import java.io.PrintWriter
import java.io.StringWriter

fun getExceptionDetail(e: Throwable): String {
    val sw = StringWriter()
    val pw = PrintWriter(sw)
    e.printStackTrace(pw)
    return sw.toString()
}

fun getKeyStackTrace(e: Throwable): String {
    val appPackage = MyApplication.context.packageName
    val sw = StringWriter()
    val pw = PrintWriter(sw)
    e.printStackTrace(pw)
    val lines = sw.toString().lines()

    val firstLine = lines.firstOrNull()?.trim() ?: "Unknown Exception"
    val appStackLine = lines.firstOrNull { it.trim().startsWith("at $appPackage") }?.trim()

    return if (appStackLine != null) {
        "原因: $firstLine\n位置: $appStackLine\n提示: 报错并未一定代码有误，有可能是登录失效，无法获取信息"
    } else {
        firstLine
    }
}

